************************************************************************
      PROGRAM fouriert
* Write down your function at the end of the program.
* Output: frequency, power spectrum, real part, imaginary part
************************************************************************
* np = number of points to evaluate the function and its transform
      INTEGER np
      PARAMETER (np=10000)

* om = frequency of the transform (radians per unit time)
* sdpi = 1/sqrt(two pi)
      DOUBLE PRECISION om,sdpi
      COMMON /freq/om,sdpi

      INTEGER i
      DOUBLE PRECISION gr1,gr2,gr3,gr,gi1,gi2,gi3,gi,g,funcsin,funccos,
     & funcsinu,funccosu,gauss8
      EXTERNAL funcsin,funccos,funcsinu,funccosu,gauss8

* Two pi
      sdpi=1d0/SQRT(2d0*ACOS(-1d0))

      OPEN(60,FILE='Ex1.out')
* Integrals of the transform
      DO i=-np/2,np/2
         om=DBLE(i)/np*25d0
         gr1=gauss8(96,0d0,-1d0,funccosu)
         gr2=gauss8(96,-1d0,1d0,funccos)
         gr3=gauss8(96,1d0,0d0,funccosu)
         gr=gr1+gr2+gr3
         gi1=gauss8(96,0d0,-1d0,funcsinu)
         gi2=gauss8(96,-1d0,1d0,funcsin)
         gi3=gauss8(96,1d0,0d0,funcsinu)
         gi=gi1+gi2+gi3
         g=SQRT(gr**2+gi**2)
         WRITE(60,*)om,g,gr,gi
      ENDDO
      CLOSE(60)
      END

************************************************************************
      FUNCTION funccos(t)
      DOUBLE PRECISION funccos,t
* Real part of the integrand
************************************************************************
* om = frequency of the transform (radians per unit time)
* sdpi = 1/sqrt(two pi)
      DOUBLE PRECISION om,sdpi
      COMMON /freq/om,sdpi

      DOUBLE PRECISION f

      funccos=sdpi*f(t)*COS(om*t)
      END
************************************************************************
      FUNCTION funccosu(t)
      DOUBLE PRECISION funccosu,t
* Real part of the integrand (with change of variable)
************************************************************************
* om = frequency of the transform (radians per unit time)
* sdpi = 1/sqrt(two pi)
      DOUBLE PRECISION om,sdpi
      COMMON /freq/om,sdpi

      DOUBLE PRECISION f,u

      u=1d0/t
      funccosu=-sdpi*u**2*f(u)*COS(om*u)
      END
************************************************************************
      FUNCTION funcsin(t)
      DOUBLE PRECISION funcsin,t
* Imaginary part of the integrand
************************************************************************
* om = frequency of the transform (radians per unit time)
* sdpi = 1/sqrt(two pi)
      DOUBLE PRECISION om,sdpi
      COMMON /freq/om,sdpi

      DOUBLE PRECISION f

      funcsin=-sdpi*f(t)*SIN(om*t)
      END
************************************************************************
      FUNCTION funcsinu(t)
      DOUBLE PRECISION funcsinu,t
* Imaginary part of the integrand (with change of variable)
************************************************************************
* om = frequency of the transform (radians per unit time)
* sdpi = 1/sqrt(two pi)
      DOUBLE PRECISION om,sdpi
      COMMON /freq/om,sdpi

      DOUBLE PRECISION f,u

      u=1d0/t
      funcsinu=sdpi*u**2*f(u)*SIN(om*u)
      END

      INCLUDE 'gauss8.fun'

************************************************************************
      FUNCTION f(t)
      DOUBLE PRECISION f,t
* We look for the Fourier transform of this function.
************************************************************************
* Gaussian
      DOUBLE PRECISION sig
      PARAMETER (sig=0.5d0)
      LOGICAL prim
      DOUBLE PRECISION nor,sig2
      SAVE nor,sig2,prim
      DATA prim/.TRUE./
      IF(prim)THEN
         sig2=2d0*sig**2
         nor=1d0/SQRT(ACOS(-1d0)*sig2)
         prim=.FALSE.
      ENDIF
      f=nor*EXP(-t**2/sig2)

* Top hat
c      DOUBLE PRECISION per
c      PARAMETER (per=1d0)
c      IF(ABS(t).LT.per/2d0)THEN
c         f=1d0/per
c      ELSE
c         f=0d0
c      ENDIF

* 4th negative exponential
c      f=EXP(-t**4)
      END
