************************************************************************
      PROGRAM discretef
************************************************************************
* np = number of points to evaluate the function and its transform
      INTEGER np
      PARAMETER (np=16384)

      INTEGER i
      DOUBLE PRECISION ff(np),t,f,dpi,deltaom,period,om,pow,re,im

* Two pi
      dpi=2d0*ACOS(-1d0)
* Period
      period=50d0
* Delta omega
      deltaom=dpi/period

* Generate the input
      OPEN(60,FILE='Ex2-function.out')
      DO i=0,np-1
         t=DBLE(i)/np*period
         ff(i+1)=f(t)
         WRITE(60,*)t,ff(i+1)
      ENDDO
      CLOSE(60)
* Discrete Fourier transform
      CALL fft8(ff,np,1)
* Output
      OPEN(60,FILE='Ex2-discrete.out')
      DO i=-np/2+1,np/2-1
         om=i*deltaom
         re=ff(2*ABS(i)+1)/(np/2)
         im=ff(2*ABS(i)+2)/(np/2)
         IF(i.EQ.0)im=0d0
         pow=SQRT(re**2+im**2)
         WRITE(60,*)om,pow,re,im
      ENDDO
      CLOSE(60)
      END

      INCLUDE 'fft8.sub'

************************************************************************
      FUNCTION f(t)
      DOUBLE PRECISION f,t
* We look for the Fourier transform of this function.
************************************************************************
* Sine
      DOUBLE PRECISION dpi
      PARAMETER (dpi=6.2831853071795862d0)
      DOUBLE PRECISION freq,amp,phase
      PARAMETER (freq=1d0,amp=1d0,phase=-dpi/4d0)
      f=amp*SIN(dpi*freq*t+phase)

* Dirac comb
c      INTEGER i,np
c      DOUBLE PRECISION tt,period
c      np=16384               !!! These two numbers should be
c      period=100d0           !!! the same as in the main
c      f=0d0
c      tt=ABS(t*np/period)
c      IF(MOD(INT(tt),100).EQ.0)f=1d0

* Four sines
c      DOUBLE PRECISION dpi
c      PARAMETER (dpi=6.2831853071795862d0)
c      f=SIN(dpi*t)+0.5d0*SIN(dpi*2*t)+0.25d0*SIN(dpi*3*t)+
c     & 0.1d0*SIN(dpi*4*t)
* Top Hat
c      DOUBLE PRECISION per
c      PARAMETER (per=1d0)
c      IF(ABS(t).LT.per/2d0)THEN
c         f=1d0/per
c      ELSE
c         f=0d0
c      ENDIF
* Four sines and top hat
c      DOUBLE PRECISION dpi
c      PARAMETER (dpi=6.2831853071795862d0)
c      DOUBLE PRECISION per
c      PARAMETER (per=dpi)
c      IF(ABS(t).LT.per/2d0)THEN
c         f=SIN(dpi*t)+0.5d0*SIN(dpi*2*t)+0.25d0*SIN(dpi*3*t)+
c     &    0.1d0*SIN(dpi*4*t)/per
c      ELSE
c         f=0d0
c      ENDIF
      END
