************************************************************************
      PROGRAM periodogram
* Classical periodogram: pseudo-Nyquist frequency
************************************************************************
* Number of observations, number of frequencies of the periodogram
      INTEGER np,nom
      PARAMETER (np=100,nom=105)

      INTEGER i,j
      DOUBLE PRECISION t(np),f(np),azar8,noise,om,pg,pcos,psin

* Generate input
      OPEN(60,FILE='Ex3-obs.out')

* To show pseudo-Nyquist frequency
      DO i=1,np
         t(i)=azar8()*1200d0
         noise=2d0*azar8()-1d0
         f(i)=10d0+7.5d0*SIN(100d0*t(i))+noise
         WRITE(60,*)t(i),f(i)
      ENDDO
      CLOSE(60)
* Periodogram
      OPEN(60,FILE='Ex3-periodogram.out')
      DO j=0,nom
         om=10d0**(-2d0+j*0.04d0) ! logarithmic scale to visualize
         pcos=0d0
         DO i=1,np
            pcos=pcos+f(i)*COS(om*t(i))
         ENDDO
         psin=0d0
         DO i=1,np
            psin=psin+f(i)*SIN(om*t(i))
         ENDDO
         pg=(pcos**2+psin**2)/np**2
         WRITE(60,*)LOG10(om),pg
      ENDDO
      CLOSE(60)
      END

      INCLUDE 'azar8.fun'
