************************************************************************
      PROGRAM lsperiodogram
* Lomb-Scargle periodogram
************************************************************************
* Number of observations, number of frequencies of the periodogram
      INTEGER np,nom
      PARAMETER (np=100,nom=100)

      INTEGER i,j,npp
      DOUBLE PRECISION t(np),f(np),azar8,noise,om,pg,s,c,tau,fc,fs,
     & s2,c2,arg,dpi

      npp=np
* Generate input
      OPEN(60,FILE='Ex4-obs.out')
* To show how the periodogram is fooled by a mean value
      dpi=2d0*ACOS(-1d0)
      DO i=1,npp
         t(i)=azar8()*100d0
         noise=azar8()-0.5d0
         f(i)=16d0+2d0*SIN(dpi*0.3d0*t(i))+noise
c         f(i)=2d0*SIN(dpi*0.3d0*t(i))+noise
         WRITE(60,*)t(i),f(i),MOD(t(i),1d0/0.3d0)
      ENDDO
      CLOSE(60)
* Limiting magnitude
c      j=0
c      arg=0d0
c      DO i=1,npp
c         IF(f(i).LT.16.8d0)THEN
c            j=j+1
c            t(j)=t(i)
c            f(j)=f(i)
c            arg=arg+f(j)
c         ENDIF
c      ENDDO
c      npp=j
c      arg=arg/npp
c      OPEN(60,FILE='Ex4-obs.out')
c      DO i=1,npp
c         f(i)=f(i)-arg
c         WRITE(60,*)t(i),f(i),MOD(t(i),1d0/0.3d0)
c      ENDDO
c      CLOSE(60)
         
* Lomb-Scargle periodogram
      OPEN(60,FILE='Ex4-periodogram.out')
      DO j=1,nom
         om=dpi*j/DBLE(nom) ! frequencies to evaluate
* Tau
         s=0d0
         c=0d0
         DO i=1,npp
            s=s+SIN(2d0*om*t(i))
            c=c+COS(2d0*om*t(i))
         ENDDO
         tau=ATAN2(s,c)/(2d0*om)
* Periodogram
         fc=0d0
         fs=0d0
         s2=0d0
         c2=0d0
         DO i=1,npp
            arg=om*(t(i)-tau)
            s=SIN(arg)
            c=COS(arg)
            fs=fs+f(i)*s
            fc=fc+f(i)*c
            s2=s2+s**2
            c2=c2+c**2
         ENDDO
         pg=0.5d0*(fc**2/c2+fs**2/s2)
         WRITE(60,*)om/dpi,pg
      ENDDO
      CLOSE(60)
      END

      INCLUDE 'azar8.fun'
