************************************************************************
      PROGRAM fap
* False alarm probability
************************************************************************
* Number of observations, number of frequencies of the periodogram
      INTEGER np,nom
      PARAMETER (np=100,nom=100)

      INTEGER i,j,npp
      DOUBLE PRECISION t(np),f(np),azar8,noise,om,pg,s,c,s2,c2,sc,tau,
     & arg,dpi,num,den,fs,fc,ff,ter1,ter2,som,com,pgmax,prob,z

      npp=np
* Generate input
      dpi=2d0*ACOS(-1d0)
      DO i=1,npp
         t(i)=azar8()*100d0
         noise=azar8()-0.5d0
         f(i)=16d0+2d0*SIN(dpi*0.3d0*t(i))+noise
      ENDDO
* Limiting magnitude
      j=0
      DO i=1,npp
         IF(f(i).LT.16.8d0)THEN
            j=j+1
            t(j)=t(i)
            f(j)=f(i)
         ENDIF
      ENDDO
      npp=j
* Lomb-Scargle periodogram with floating mean
      pgmax=0d0
      DO j=1,nom
         om=dpi*j/DBLE(nom) ! frequencies to evaluate
* Tau
         s=0d0
         c=0d0
         s2=0d0
         c2=0d0
         sc=0d0
         DO i=1,npp
            som=SIN(om*t(i))
            com=COS(om*t(i))
            s=s+som
            c=c+com
            s2=s2+som**2
            c2=c2+com**2
            sc=sc+som*com
         ENDDO
         num=2d0*(sc-s*c)
         den=c2-s2-(c**2-s**2)
         tau=ATAN2(num,den)/(2d0*om)
* Periodogram
         s=0d0
         c=0d0
         s2=0d0
         c2=0d0
         ff=0d0
         fs=0d0
         fc=0d0
         DO i=1,npp
            arg=om*(t(i)-tau)
            som=SIN(arg)
            com=COS(arg)
            s=s+som
            c=c+com
            s2=s2+som**2
            c2=c2+com**2
            ff=ff+f(i)
            fs=fs+f(i)*som
            fc=fc+f(i)*com
         ENDDO
         ter1=(fc-ff*c/npp)**2/(c2-c**2/npp)
         ter2=(fs-ff*s/npp)**2/(s2-s**2/npp)
         pg=0.5d0*(ter1+ter2)
         pgmax=MAX(pgmax,pg)
      ENDDO
* FAP
      OPEN(60,FILE='Ex6-fap.out')
      DO i=1,9
         prob=0.01d0*i
         z=-LOG(1d0-(1d0-prob)**(1d0/npp))
         WRITE(60,*)prob,z
         prob=0.1d0*i
         z=-LOG(1d0-(1d0-prob)**(1d0/npp))
         WRITE(60,*)prob,z
      ENDDO
      CLOSE(60)
      END

      INCLUDE 'azar8.fun'
