************************************************************************
      FUNCTION gauss8(n,xinf,xsup,fun)
      INTEGER n
      DOUBLE PRECISION fun,gauss8,xinf,xsup
      EXTERNAL fun
* Integra por el mtodo de Gauss con n puntos.
* Entradas: n    - orden de integracin (n abscisas)
*           xinf - lmite inferior de integracin 
*           xsup - lmite superior de integracin
*           fun  - funcin a integrar
************************************************************************
      INTEGER nmax
      PARAMETER (nmax=96)
      INTEGER i,nn
      DOUBLE PRECISION p(nmax),x(nmax),dsint,t
      SAVE
      DATA nn/0/

      IF(nn.NE.n)THEN
         nn=n
         CALL gausspw8(0d0,1d0,x,p,nn)
      ENDIF

      dsint=0d0
      DO i=1,nn
         t=x(i)*(xsup-xinf)+xinf
         dsint=dsint+fun(t)*p(i)
      ENDDO
      gauss8=dsint*(xsup-xinf)
      END

************************************************************************
      SUBROUTINE gausspw8(x1,x2,x,w,n)
      INTEGER n
      DOUBLE PRECISION x1,x2,x(n),w(n)
* Calcula las abscisas y sus pesos para integrar por Gauss con n puntos
* entre las abscisas x1 y x2.
************************************************************************
      DOUBLE PRECISION eps
      PARAMETER (eps=3d-14)
      INTEGER i,j,m
      DOUBLE PRECISION p1,p2,p3,pp,xl,xm,z,z1
      m=(n+1)/2
      xm=0.5d0*(x2+x1)
      xl=0.5d0*(x2-x1)
      DO i=1,m
         z=COS(ACOS(-1d0)*(i-0.25d0)/(n+0.5d0))
1        p1=1d0
         p2=0d0
         DO j=1,n
            p3=p2
            p2=p1
            p1=((2d0*j-1d0)*z*p2-(j-1d0)*p3)/j
         ENDDO
         pp=n*(z*p1-p2)/(z*z-1d0)
         z1=z
         z=z1-p1/pp
         IF(ABS(z-z1).GT.eps)GOTO 1
         x(i)=xm-xl*z
         x(n+1-i)=xm+xl*z
         w(i)=2d0*xl/((1d0-z*z)*pp**2)
         w(n+1-i)=w(i)
      ENDDO
      END
